#ifndef _ARBRE_H
#define _ARBRE_H

#include "liste.h"

typedef struct {
    int nbocc;			// Nombre d'occurence d'un mot dans un texte
    liste positions;		// Liste de positions de phrases dans le texte o 
    // le mot apparait
} infos;

typedef struct _noeud {
    char c;			// caractre de l'arbre dictionnaire
    infos *info;		// pointeur vers les informations d'un mot ( c == '\0 )
    struct _noeud *fg, *fils, *fd;	// frre gauche, fils, frre droit
} noeud, *arbre;

/* Initialise la racine comme le prefixe vide
 * */
arbre arbre_init(void);
/* Retourne 0 si tout c'est bien pass 1 sinon 
 * */
int arbre_ajout(arbre a, char *mot, long int position);
/* Retourne le noeud s'il est trouv NULL sinon
 * */
#define arbre_recherche(a,b) arbre_recherche_((a),(b),0)
noeud *arbre_recherche_(arbre a, char *mot, int position);
/* Libere la memoire allouer pour l'arbre
 * */
void arbre_detruire(arbre * a);
/* Affiche tous les mots de l'arbre
 * */
int arbre_afficheOccurences(arbre a, char *mot);
/* Affiche les occurences du mot
 * i=0 et le buf est un tableau pour la creation d'un mot 
 * doit etre d'une taille suffisante*/
void arbre_afficheMots(arbre a, char *buf, int i);
/* Affiche les occurences du mot
 * */
int arbre_affichePhrases(arbre a, char *mot, char *texte);

#endif
/* _ARBRE_H */
