#include "backup.h"


void backup_sauveRec(arbre a, FILE * fichier, char *buf, int i)
{
    if (a == NULL)
	return;
    backup_sauveRec(a->fg, fichier, buf, i);
    if (a->c != 0) {
	buf[i] = a->c;
	i++;
    } else {
	buf[i] = '\0';
	i++;
	fprintf(fichier, "%s,", buf);
	fprintf(fichier, "%d,", a->info->nbocc);
	liste temp = a->info->positions;
	while (temp != NULL) {
	    fprintf(fichier, "%ld, ", temp->v);
	    temp = temp->suiv;
	}
	fprintf(fichier, "\n");
    }
    backup_sauveRec(a->fils, fichier, buf, i);
    i--;
    backup_sauveRec(a->fd, fichier, buf, i);
    i--;
}

int backup_sauvegarde(arbre a, char *name)
{
    FILE *fichier;
    char buf[80];
    fichier = fopen(name, "w");
    if (fichier == NULL)
	return 0;
    backup_sauveRec(a->fils, fichier, buf, 0);
    fclose(fichier);
    return 1;
}

/*
 * Affiche le premier mot de chaque ligne du fichier dico
 * (qui doit tre un Index)
 */
void backup_afficheMots(FILE * dico)
{
    char *ligne = NULL;
    size_t tbuf = 0;
    int pos;

    while (getline(&ligne, &tbuf, dico) != EOF) {
	// N'affiche que le premier mot de la ligne
	for (pos = 0; ligne[pos] != ','; pos++)
	    putchar(ligne[pos]);
	putchar('\n');
    }

    free(ligne);
}

/*
 * Compare un mot avec le dbut d'une ligne ( d'Index )
 * Affiche son nombre d'occurences ainsi que la liste des occurences s'il
 * correspond.
 */
int occurrences(char *ligne, char *mot)
{
    // Vrifie si cette ligne contient le mot cherch
    while (*ligne != ',' && *mot != 0) {
	if (*ligne != *mot)
	    return 0;
	ligne++;
	mot++;
    }

    if (*mot != 0 || *ligne != ',')
	return 0;

    // Passe la virgule
    ligne++;

    printf("Nombre d'occurences : ");
    while (*ligne != ',')
	putchar(*ligne++);
    putchar('\n');

    // Passe la virgule
    ligne++;

    while (*ligne != 0)
	putchar(*ligne++);

    return 1;
}

/*
 * Affiche les occurences d'un mot s'il est prsent
 */
void backup_afficheOccurences(FILE * dico, char *mot)
{
    char *ligne = NULL;
    size_t tbuf = 0;

    while (getline(&ligne, &tbuf, dico) != EOF)
	if (occurrences(ligne, mot)) {
	    free(ligne);
	    return;
	}

    free(ligne);

    printf("%s introuvable\n", mot);
}

/*
 * Compare un mot avec le dbut d'une ligne ( d'Index )
 * Affiche les phrases o le mot apparait d'aprs la ligne.
 */
int phrases(char *ligne, char *mot, char *nom_texte)
{
    FILE *texte = NULL;
    long int position;
    char c = 0;

    // Vrifie si cette ligne contient le mot cherch
    while (*ligne != ',' && *mot != 0) {
	if (*ligne != *mot)
	    return 0;
	ligne++;
	mot++;
    }

    if (*mot != 0 || *ligne != ',')
	return 0;

    // On passe la virgule et le nombre d'occurences
    ligne++;
    while (*ligne != ',')
	ligne++;
    ligne++;

    // Ouverture du texte
    texte = fopen(nom_texte, "r");
    if (texte == NULL) {
	perror(nom_texte);
	return -1;
    }
    // Affichage des phrases
    while (*ligne != 0) {
	// Lit la position
	sscanf(ligne, "%ld", &position);
	while (*ligne != ',' && *ligne != '\n')
	    ligne++;
	ligne++;

	// Affiche
	fseek(texte, position, SEEK_SET);
	while ((c = fgetc(texte)) != '.' && c != '?' && c != '!'
	       && c != EOF)
	    putchar(c);
	putchar('\n');
    }

    fclose(texte);

    return 1;
}

/*
 * Affiche les phrases o un mot est prsent s'il existe dans le texte.
 */
void backup_affichePhrases(FILE * dico, char *mot, char *nom_texte)
{
    char *ligne = NULL;
    size_t tbuf = 0;

    while (getline(&ligne, &tbuf, dico) != EOF)
	if (phrases(ligne, mot, nom_texte)) {
	    free(ligne);
	    return;
	}

    free(ligne);

    printf("%s introuvable\n", mot);
}

/*
 * Retourne vrai si mot correspond au dbut de ligne
 */
int appartient(char *ligne, char *mot)
{
    // Vrifie si cette ligne contient le mot cherch
    while (*ligne != ',' && *mot != 0) {
	if (*ligne != *mot)
	    return 0;
	ligne++;
	mot++;
    }

    if (*mot != 0 || *ligne != ',')
	return 0;

    return 1;
}


int backup_appartient(FILE * dico, char *mot)
{
    char *ligne = NULL;
    size_t tbuf = 0;

    while (getline(&ligne, &tbuf, dico) != EOF)
	if (appartient(ligne, mot)) {
	    free(ligne);
	    return 1;
	}

    free(ligne);

    return 0;
}
