#ifndef _BACKUP_H
#define _BACKUP_H

#define _GNU_SOURCE
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "arbre.h"

/*
 * Sauvegarde l'arbre lexicographique donné dans le fichier name
 */
int backup_sauvegarde(arbre a,char *name);

/*
 * Affiche le premier mot de chaque ligne du fichier dico
 * (qui doit être un Index)
 */
void backup_afficheMots(FILE * dico);

/*
 * Affiche les occurences d'un mot s'il est présent
 */
void backup_afficheOccurences(FILE * dico, char * m);

/*
 * Affiche les phrases où un mot est présent s'il existe dans le texte.
 */
void backup_affichePhrases(FILE * dico, char * mot, char * texte);

/*
 * Retourne 1 si mot appartient au texte, 0 sinon
 */
int backup_appartient(FILE * dico, char * mot);

#endif /* _BACKUP_H */
