#include "chaines.h"

/*
 * Met une chaine de caractres en majuscules, accents compris.
 * ( conforme avec ISO-8859-15 / ISO-8859-1 )
 */
void chaines_upper(unsigned char *chaines)
{
    assert(chaines != NULL);

    while (*chaines != '\0') {
	if (*chaines < 0x7F) {	// *chaines fait partie du code ASCII
	    *chaines = toupper(*chaines);
	} else {
	    if (*chaines > 0xE0)	//*chaines est une lettre accentue minuscule
		*chaines -= 32;	// 32 = ''-''
	}
	chaines++;
    }
}

/*
 * Met une chaine de caractres en minuscules, accents compris.
 * ( conforme avec ISO-8859-15 / ISO-8859-1 )
 */
void chaines_lower(unsigned char *chaine)
{
    assert(chaine != NULL);

    while (*chaine != 0) {
	if (*chaine < 0x7F)	// *chaine fait partie du code ASCII
	    *chaine = tolower(*chaine);
	else if (*chaine >= 0xC0 && *chaine <= 0xDE)
	    // *chaine est une lettre accentue majuscule
	    *chaine += 32;	// 32 = ''-''
	chaine++;
    }
}
