#include "main.h"

action options(int argc, char **argv)
{
    int option = getopt(argc, argv, "a:lp:P:?h");

    switch (option) {
    case 'a':
	return APPARTENANCE;
    case 'l':
	return AFFICHAGE;
    case 'p':
	return POSITIONS;
    case 'P':
	return PHRASES;
    case '?':
    case 'h':
	return AIDE;
    }

    return ERREUR;
}

int lecture(char *nom_fichier, arbre a)
{
    Mots *m = NULL;
    char *mot = NULL;
    int pos = 0;

    m = parseur_init(nom_fichier);
    if (m == NULL)
	return 0;

    while ((pos = parseur_lire(m, &mot)) != EOF) {
	chaines_lower((unsigned char *) mot);
	if (!arbre_ajout(a, mot, pos))
	    return 0;
    }

    parseur_fin(m);

    return 1;
}

void aide(char *argv0)
{
    printf("Usage : %s [-a|-l|-p|-P|-?|-h] <option> <fichier>\n", argv0);
    puts("  -a : teste l'appartenance de <option> au texte de <fichier>.");
    puts("  -l : affiche la liste des mots du texte <fichier>.");
    puts("  -p : affiche les positions des phrases o apparait <option> dans\n" "       le texte de <fichier>.");
    puts("  -P : affiche les phrases o apparait <option> dans le texte de\n" "       <fichier>.");
    puts("  -? : affiche cet aide");
    puts("  -h : affiche cet aide");
    puts("<fichier> est un fichier texte au format ISO-8859-15.");
}

int main(int argc, char **argv)
{
    arbre lex = NULL;
    char *dico_nomfichier = NULL;
    action a = ERREUR;
    char buf[25];
    FILE *dico = NULL;

    a = options(argc, argv);
    if (a == ERREUR) {
	fprintf(stderr, "Action inconnue\n");
	aide(argv[0]);
	return 1;
    }

    if (a == AIDE) {
	aide(argv[0]);
	return 0;
    }

    if (a != AFFICHAGE)
	chaines_lower((unsigned char *) optarg);

    if (optind >= argc) {
	fprintf(stderr, "Pas de fichier texte spcifi\n");
	return 2;
    }
    // On cr le nomdutexte.Index
    dico_nomfichier = malloc(strlen(argv[optind]) + 7);
    // 7 = strlen(".Index") + \0
    strcpy(dico_nomfichier, argv[optind]);
    strcat(dico_nomfichier, ".Index");

    // Si on n'a pas de dictionnaire, on le cr et fait le traitement demand
    dico = fopen(dico_nomfichier, "r");
    if (dico == NULL) {
	lex = arbre_init();

	if (!lecture(argv[optind], lex)) {
	    fprintf(stderr,
		    "Erreur fatale, lecture du texte impossible !\n");
	    arbre_detruire(&lex);
	    return 3;
	}

	switch (a) {
	case APPARTENANCE:
	    if (arbre_recherche(lex->fils, optarg))
		printf("%s appartient au texte\n", optarg);
	    else
		printf("%s n'appartient pas au texte\n", optarg);
	    break;
	case AFFICHAGE:
	    arbre_afficheMots(lex->fils, buf, 0);
	    break;
	case POSITIONS:
	    arbre_afficheOccurences(lex->fils, optarg);
	    break;
	case PHRASES:
	    arbre_affichePhrases(lex, optarg, argv[optind]);
	case ERREUR:
	case AIDE:
	    break;
	}

	backup_sauvegarde(lex, dico_nomfichier);

	arbre_detruire(&lex);
	// Si on l'a, on fait directement le traitement dessus
    } else {
	switch (a) {
	case APPARTENANCE:
	    if (backup_appartient(dico, optarg))
		printf("%s appartient au texte\n", optarg);
	    else
		printf("%s n'appartient pas au texte\n", optarg);
	    break;
	case AFFICHAGE:
	    backup_afficheMots(dico);
	    break;
	case POSITIONS:
	    backup_afficheOccurences(dico, optarg);
	    break;
	case PHRASES:
	    backup_affichePhrases(dico, optarg, argv[optind]);
	case ERREUR:
	case AIDE:
	    break;
	}

	fclose(dico);
    }

    free(dico_nomfichier);

    return 0;
}
