#include "parseur.h"

/* 
 * Initialise le parseur
 */
Mots *parseur_init(char *fichier)
{
    Mots *m = NULL;

    m = malloc(sizeof(Mots));
    if (m == NULL)
	return NULL;

    m->ligne = NULL;
    m->tampon = 0;
    m->longueur = 0;
    m->position = 0;
    m->fichier = fopen(fichier, "r");
    if (m->fichier == NULL) {
	free(m);
	perror(fichier);
	return NULL;
    }
    m->phrase = 0;

    return m;
}

/* 
 * Termine le parseur
 */
void parseur_fin(Mots * m)
{
    free(m->ligne);
    fclose(m->fichier);
    free(m);
}

/*
 * Lit un mot. Le parseur lit une nouvelle ligne avec getline si celle lue
 * en cours est termine puis cherche le prochain sparateur de mot (0, \n ou
 * espace), le remplace par un 0 et incrmente position de manire  trouver
 * le prochain lors du prochain appel  lire_mot
 * Retourne la position du dbut de la phrase du nouveau mot. (en octets)
 */
long int parseur_lire(Mots * m, char **mot)
{
    int nouvellephrase = 0;
    long int ret = m->phrase;

    // Si la ligne est termine on en lit une nouvelle non-vide
    while (m->position >= m->longueur) {
	m->octetslu += m->position;

	m->longueur = getline(&(m->ligne), &(m->tampon), m->fichier);
	if (m->longueur == EOF)
	    return EOF;

	// Efface le \n final
	//m->longueur--;
	m->ligne[m->longueur - 1] = 0;

	m->position = 0;

	// Efface les ventuels blancs en dbut de nouvelle ligne
	while (isspace(m->ligne[m->position]))
	    m->position++;
    }

    *mot = &(m->ligne[m->position]);

    // Avance jusqu' la fin du mot
    while (!isSeparator(m->ligne[m->position]))
	m->position++;

    if (m->ligne[m->position] == '.'
	|| m->ligne[m->position] == '!' || m->ligne[m->position] == '?')
	nouvellephrase = 1;

    // Fin du mot trouve, on le note par un '\0'
    m->ligne[m->position] = 0;
    m->position++;

    // Cherche le dbut du prochain mot
    while (isspace(m->ligne[m->position]))
	m->position++;

    if (nouvellephrase)
	m->phrase = m->octetslu + m->position;

    return ret;
}
