#ifndef _PARSEUR_H
#define _PARSEUR_H

#define _GNU_SOURCE
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

typedef struct {
    char *ligne;		// Ligne courante
    size_t tampon;		// Taille du tampon mmoire de getline()
    int longueur;		// Longueur de la ligne en cours
    long int position;		// Position dans la lecture de la ligne
    FILE *fichier;		// Fichier lu
    int phrase;			// Position en octets du dbut de la phrase actuellement lue
    long int octetslu;		// Nombre d'octets lus avant la ligne courante.
} Mots;

/*
 * Macro vrifiant si un caractre est un sparateur
 */
#define isSeparator(x) (isblank((x)) || (x) == 0 || (x) == ',' || (x) == '.' \
	|| (x) == ';' || (x) == ':' || (x) == '!' || (x) == '?' )

/* 
 * Initialise le parseur
 */
Mots *parseur_init(char *fichier);
/* 
 * Termine le parseur
 */
void parseur_fin(Mots * m);
/*
 * Lit un mot. Le parseur lit une nouvelle ligne avec getline si celle lue
 * en cours est termine puis cherche le prochain sparateur de mot (0, \n ou
 * espace), le remplace par un 0 et incrmente position de manire  trouver
 * le prochain lors du prochain appel  lire_mot
 * Retourne la position du dbut de la phrase du nouveau mot. (en octets)
 */
long int parseur_lire(Mots * m, char **mot);

#endif				/* _PARSEUR_H */
